Index: contrib/init.d/rc.gentoo.asterisk
===================================================================
--- contrib/init.d/rc.gentoo.asterisk	(revision 379373)
+++ contrib/init.d/rc.gentoo.asterisk	(working copy)
@@ -20,7 +20,7 @@
 start() {
 	# Check if Asterisk is already running.  If it is, then bug out, because
 	# starting safe_asterisk when Asterisk is running is very bad.
-	VERSION=`${ASTSBINDIR}/asterisk -rx 'core show version'`
+	VERSION=`${ASTSBINDIR}/asterisk -rx 'core show version' 2>/dev/null`
 	if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
 		echo "Asterisk is already running.  $0 will exit now."
 		exit 1
Index: contrib/init.d/rc.slackware.asterisk
===================================================================
--- contrib/init.d/rc.slackware.asterisk	(revision 379373)
+++ contrib/init.d/rc.slackware.asterisk	(working copy)
@@ -24,7 +24,7 @@
    if [ -x /usr/sbin/asterisk ]; then
       # Check if Asterisk is already running.  If it is, then bug out, because
       # starting safe_asterisk when Asterisk is running is very bad.
-      VERSION=`/usr/sbin/asterisk -rx 'core show version'`
+      VERSION=`/usr/sbin/asterisk -rx 'core show version' 2>/dev/null`
 	  if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
          echo "Asterisk is already running.  $0 will exit now."
          exit 1
Index: contrib/init.d/rc.archlinux.asterisk
===================================================================
--- contrib/init.d/rc.archlinux.asterisk	(revision 379373)
+++ contrib/init.d/rc.archlinux.asterisk	(working copy)
@@ -33,7 +33,7 @@
     if [ -x $DAEMON ]; then
       # Check if Asterisk is already running.  If it is, then bug out, because
       # starting safe_asterisk when Asterisk is running is very bad.
-      VERSION=`${DAEMON} -rx 'core show version'`
+      VERSION=`${DAEMON} -rx 'core show version' 2>/dev/null`
       if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
          echo "Asterisk is already running.  $0 will exit now."
          exit 1
Index: contrib/init.d/rc.suse.asterisk
===================================================================
--- contrib/init.d/rc.suse.asterisk	(revision 379373)
+++ contrib/init.d/rc.suse.asterisk	(working copy)
@@ -78,7 +78,7 @@
 
 	# Check if Asterisk is already running.  If it is, then bug out, because
 	# starting Asterisk when Asterisk is already running is very bad.
-	VERSION=`/usr/sbin/asterisk -rx 'core show version'`
+	VERSION=`/usr/sbin/asterisk -rx 'core show version' 2>/dev/null`
 	if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
 		echo "Asterisk is already running.  $0 will exit now."
 		exit 1
Index: contrib/init.d/rc.mandriva.asterisk
===================================================================
--- contrib/init.d/rc.mandriva.asterisk	(revision 379373)
+++ contrib/init.d/rc.mandriva.asterisk	(working copy)
@@ -135,7 +135,7 @@
 	start)
 		# Check if Asterisk is already running.  If it is, then bug out, because
 		# starting Asterisk when Asterisk is already running is very bad.
-		VERSION=`${ASTSBINDIR}/asterisk -rx 'core show version'`
+		VERSION=`${ASTSBINDIR}/asterisk -rx 'core show version' 2>/dev/null`
 		if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
 			echo "Asterisk is already running.  $0 will exit now."
 			exit 1
Index: contrib/init.d/rc.debian.asterisk
===================================================================
--- contrib/init.d/rc.debian.asterisk	(revision 379373)
+++ contrib/init.d/rc.debian.asterisk	(working copy)
@@ -66,7 +66,7 @@
   start)
 	# Check if Asterisk is already running.  If it is, then bug out, because
 	# starting up Asterisk when Asterisk is already running is very bad.
-	VERSION=`${DAEMON} -rx 'core show version' || ${TRUE}`
+	VERSION=`${DAEMON} -rx 'core show version' 2>/dev/null || ${TRUE}`
 	if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
 		echo "Asterisk is already running.  $0 will exit now."
 		exit 0
Index: contrib/init.d/rc.redhat.asterisk
===================================================================
--- contrib/init.d/rc.redhat.asterisk	(revision 379373)
+++ contrib/init.d/rc.redhat.asterisk	(working copy)
@@ -71,7 +71,7 @@
 start() {
 	# Check if Asterisk is already running.  If it is, then bug out, because
 	# starting safe_asterisk when Asterisk is running is very bad.
-	VERSION=`${AST_SBIN}/asterisk -rx 'core show version'`
+	VERSION=`${AST_SBIN}/asterisk -rx 'core show version' 2>/dev/null`
 	if [ "`echo $VERSION | cut -c 1-8`" = "Asterisk" ]; then
 		echo "Asterisk is already running."
 		exit 0
Index: contrib/scripts/safe_asterisk
===================================================================
--- contrib/scripts/safe_asterisk	(revision 379373)
+++ contrib/scripts/safe_asterisk	(working copy)
@@ -45,7 +45,7 @@
 
 # Check if Asterisk is already running.  If it is, then bug out, because
 # starting safe_asterisk when Asterisk is running is very bad.
-VERSION=`${ASTSBINDIR}/asterisk -nrx 'core show version'`
+VERSION=`${ASTSBINDIR}/asterisk -nrx 'core show version' 2>/dev/null`
 if test "`echo $VERSION | cut -c 1-8`" = "Asterisk" ; then
 	message "Asterisk is already running.  $0 will exit now."
 	exit 1